"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var core_1 = require("@material-ui/core");
var utils_1 = require("../lib/utils");
var index_1 = require("./index");
var styles_1 = require("@material-ui/core/styles");
var useStyles = styles_1.makeStyles(function (theme) {
    var _a;
    return styles_1.createStyles({
        controls: (_a = {
                display: 'flex',
                alignItems: 'center'
            },
            _a[theme.breakpoints.down('sm')] = {
                justifyContent: 'space-around',
            },
            _a),
        videoContainer: {
            backgroundColor: theme.palette.common.black,
            display: 'inline-block',
        },
        video: {
            width: function (props) { return props.width; },
            height: function (props) { return props.height; },
        },
        actions: {
            display: 'flex',
            flexDirection: 'column',
            alignItems: 'center',
            paddingTop: theme.spacing(1),
            paddingRight: theme.spacing(2),
            paddingLeft: theme.spacing(2),
            paddingBottom: theme.spacing(1),
            '&:last-child': {
                paddingBottom: theme.spacing(1),
            },
        },
        card: {
            display: 'flex',
            flexDirection: 'column',
        },
        cardContent: {
            display: 'flex',
            justifyContent: 'center',
        }
    });
});
var MaterialUIVideo = function (props) {
    var _a = react_1.useState(''), url = _a[0], setUrl = _a[1];
    var _b = react_1.useState(false), playing = _b[0], setPlaying = _b[1];
    var _c = react_1.useState({}), time = _c[0], setTime = _c[1];
    var _d = react_1.useState(1), fade = _d[0], setFade = _d[1];
    var _e = react_1.useState((props.width || 0) * 9 / 16), height = _e[0], setHeight = _e[1];
    var _f = react_1.useState(props.width), width = _f[0], setWidth = _f[1];
    var _g = react_1.useState(null), playerTimeout = _g[0], setPlayerTimeout = _g[1];
    var player = react_1.useRef(null);
    var pausePlaying = react_1.useCallback(function () {
        var _a;
        (_a = player === null || player === void 0 ? void 0 : player.current) === null || _a === void 0 ? void 0 : _a.pause();
        playerTimeout && clearInterval(playerTimeout);
        setPlaying(false);
    }, [playerTimeout]);
    var setCurrentTime = react_1.useCallback(function (value) {
        if (!(player === null || player === void 0 ? void 0 : player.current))
            return;
        var currentTime = (value / 100) * (player.current.duration || 0);
        player.current.currentTime = currentTime;
        var progressTime = {
            currentTime: player.current.currentTime,
            duration: player.current.duration,
        };
        setTime(progressTime);
    }, []);
    var setSize = react_1.useCallback(function () {
        if (!(player === null || player === void 0 ? void 0 : player.current))
            return;
        if (width) {
            setHeight(player.current.videoHeight * width / player.current.videoWidth);
            return;
        }
        setWidth(player.current.videoWidth);
        setHeight(player.current.videoHeight);
    }, [width]);
    var stop = react_1.useCallback(function () {
        pausePlaying();
        setCurrentTime(0);
    }, [pausePlaying, setCurrentTime]);
    var src = props.src, _h = props.onEnded, onEnded = _h === void 0 ? function () { return setCurrentTime(0); } : _h, _j = props.onBackwardClick, onBackwardClick = _j === void 0 ? function () { } : _j, _k = props.onForwardClick, onForwardClick = _k === void 0 ? function () { } : _k, _l = props.loop, loop = _l === void 0 ? !!props.loop : _l, _m = props.autoplay, autoplay = _m === void 0 ? !!props.autoplay : _m, fadeSettings = props.fadeSettings;
    var classes = useStyles({ width: width, height: height });
    var intervalCheck = react_1.useCallback(function () {
        if (!(player === null || player === void 0 ? void 0 : player.current))
            return;
        var currentFade = utils_1.getFade(fadeSettings, player.current.duration, player.current.currentTime);
        setFade(currentFade);
        var progressTime = {
            currentTime: player.current.currentTime,
            duration: player.current.duration,
        };
        setTime(progressTime);
    }, [fadeSettings]);
    var onPlay = react_1.useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        var videoUrl, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!(player === null || player === void 0 ? void 0 : player.current))
                        return [2 /*return*/];
                    if (!!player.current.src) return [3 /*break*/, 4];
                    if (!(typeof src === 'string')) return [3 /*break*/, 1];
                    _a = src;
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, src];
                case 2:
                    _a = _b.sent();
                    _b.label = 3;
                case 3:
                    videoUrl = _a;
                    setUrl(videoUrl);
                    player.current.src = videoUrl;
                    player.current.load();
                    player.current.onloadedmetadata = setSize;
                    _b.label = 4;
                case 4:
                    setPlaying(true);
                    setPlayerTimeout(setInterval(intervalCheck, 50));
                    player.current.play();
                    return [2 /*return*/];
            }
        });
    }); }, [player, intervalCheck, src, setSize]);
    react_1.useEffect(function () {
        if (!(player === null || player === void 0 ? void 0 : player.current))
            return;
        player.current.autoplay = autoplay;
        player.current.loop = loop;
        player.current.onended = function () {
            pausePlaying();
            onEnded();
        };
        stop();
        if (typeof src === 'string') {
            setUrl(src);
            player.current.src = src;
            player.current.load();
            player.current.onloadedmetadata = setSize;
        }
        return function () {
            playerTimeout && clearInterval(playerTimeout);
        };
    }, [src]);
    var onVolumeChange = react_1.useCallback(function (volume) {
        if (!(player === null || player === void 0 ? void 0 : player.current))
            return;
        player.current.volume = volume;
    }, []);
    var onMuteClick = react_1.useCallback(function (muted) {
        if (!(player === null || player === void 0 ? void 0 : player.current))
            return;
        player.current.muted = muted;
    }, []);
    var onSpeedChange = react_1.useCallback(function (speed) {
        if (!(player === null || player === void 0 ? void 0 : player.current))
            return;
        player.current.playbackRate = speed;
    }, []);
    var onProgressClick = react_1.useCallback(function (value) { return __awaiter(void 0, void 0, void 0, function () {
        var videoUrl, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!(player === null || player === void 0 ? void 0 : player.current))
                        return [2 /*return*/];
                    if (!!player.current.src) return [3 /*break*/, 4];
                    if (!(typeof src === 'string')) return [3 /*break*/, 1];
                    _a = src;
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, src];
                case 2:
                    _a = _b.sent();
                    _b.label = 3;
                case 3:
                    videoUrl = _a;
                    setUrl(videoUrl);
                    player.current.src = videoUrl;
                    player.current.load();
                    player.current.onloadedmetadata = function () { return setCurrentTime(value); };
                    return [2 /*return*/];
                case 4:
                    setCurrentTime(value);
                    return [2 /*return*/];
            }
        });
    }); }, [src, setCurrentTime]);
    return (react_1.default.createElement(core_1.Card, { className: classes.card },
        react_1.default.createElement(core_1.CardContent, { className: classes.cardContent },
            react_1.default.createElement("div", { className: classes.videoContainer },
                react_1.default.createElement("video", { style: { opacity: fade }, ref: player, className: classes.video }, url && react_1.default.createElement("source", { type: utils_1.getMimeType(url), src: url })))),
        react_1.default.createElement(core_1.CardActions, { className: classes.actions },
            react_1.default.createElement(core_1.Grid, { container: true, justify: "center", alignItems: "center" },
                react_1.default.createElement(core_1.Grid, { item: true, xs: 12 },
                    react_1.default.createElement(index_1.Progress, { time: time, onProgressClick: function (v) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, onProgressClick(v)];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        }); }); } })),
                react_1.default.createElement(core_1.Grid, { item: true, xs: 12, sm: 6 },
                    react_1.default.createElement("div", { className: classes.controls },
                        react_1.default.createElement(index_1.MediaTime, { time: time }),
                        react_1.default.createElement(index_1.ControlKeys, { onPauseClick: pausePlaying, onPlayClick: onPlay, backward: props.backward, forward: props.forward, playing: playing, onForwardClick: onForwardClick, onBackwardClick: onBackwardClick, onStopClick: stop }))),
                props.speed &&
                    react_1.default.createElement(core_1.Grid, { item: true, xs: 6, sm: 3 },
                        react_1.default.createElement(index_1.SpeedBar, { onSpeedChange: onSpeedChange })),
                react_1.default.createElement(core_1.Grid, { item: true, xs: props.speed ? 6 : 12, sm: props.speed ? 3 : 6 },
                    react_1.default.createElement(index_1.VolumeBar, { onMuteClick: onMuteClick, onVolumeChange: onVolumeChange }))))));
};
exports.default = MaterialUIVideo;
//# sourceMappingURL=VideoCard.js.map